#pragma once

#include <QWidget>
#include <QPushButton>
#include <QHBoxLayout>
#include <functional>

#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include "config.hpp"
#include <QMessageBox>

class ReaderWindow : public QWidget
{
    Q_OBJECT
public:
    ReaderWindow(QWidget *parent = nullptr) : QWidget(parent)
    {
        setFixedSize(640, 480);
        auto layout = new QHBoxLayout(this);
        setLayout(layout);

        auto readButton = new QPushButton("从管道读取数据", this);
        layout->addWidget(readButton);

        show();

        connect(readButton, &QPushButton::clicked, this, &ReaderWindow::readFromFIFO);
    }

public Q_SLOTS:
    void readFromFIFO()
    {
        int fd = ::open(FIFO_NAME, O_RDONLY);
        if (fd == -1)
            return;
        char buf[4096];
        int nRead = read(fd, buf, sizeof(buf));

        if (nRead <= 0)
            return;
        std::string str(buf, nRead);
        QMessageBox::information(this, QString::fromStdString(str), QString::fromStdString(str));
    }
};
