#pragma once

#include <QWidget>
#include <QPushButton>
#include <QHBoxLayout>
#include <functional>

#include <sys/stat.h>
#include "config.hpp"
#include <unistd.h>
#include <fcntl.h>
#include <QMessageBoX>
class WriterWindow : public QWidget
{
    Q_OBJECT
public:
    WriterWindow(QWidget *parent = nullptr) : QWidget(parent)
    {
        setFixedSize(640, 480);
        auto layout = new QHBoxLayout(this);
        setLayout(layout);

        auto createButton = new QPushButton("创建管道", this);
        auto writeButton = new QPushButton("向管道写入数据", this);
        layout->addWidget(createButton);
        layout->addWidget(writeButton);

        connect(createButton, &QPushButton::clicked, this, &WriterWindow::createFifo);
        connect(writeButton, &QPushButton::clicked, this, &WriterWindow::writeSlot);

        show();
    }

Q_SIGNALS:
    void Message(const QString &);

private:
    void createFifo()
    {
        // int ret = mkfifo(FIFO_NAME, S_IFIFO | 0666);
        // if (ret == -1)
        // {
        //     printf("make file error\n");
        //     return;
        // }
        m_fd = open(FIFO_NAME, O_WRONLY);
    }
private Q_SLOTS:
    void writeSlot()
    {
        std::string hello = "hello";
        write(m_fd, hello.c_str(), hello.size());
    }

private:
    int m_fd;
};
